import gtk
import gobject
import gettext

_ = gettext.gettext

class LogViewerMenu( gtk.MenuBar ):
    '''the menu from the main window'''

    __gsignals__ = {
        'open-file' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()),
        'clear' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()),
        'quit' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, ()) }

    def __init__( self ):
        gtk.MenuBar.__init__( self )

        # build the file menu

        fileMenu = gtk.Menu()
        fileMenuItem = gtk.ImageMenuItem( _( '_File' ) )
        fileMenuItem.set_submenu( fileMenu )

        openMenuItem = gtk.ImageMenuItem( gtk.STOCK_OPEN )
        fileMenu.add( openMenuItem )
        clearMenuItem = gtk.ImageMenuItem( gtk.STOCK_CLEAR )
        fileMenu.add( clearMenuItem )
        fileMenu.add( gtk.SeparatorMenuItem() )
        quitMenuItem = gtk.ImageMenuItem( gtk.STOCK_QUIT )
        fileMenu.add( quitMenuItem )

        openMenuItem.connect( "activate" , self.onOpenActivate )
        clearMenuItem.connect( "activate" , self.onClearActivate )
        quitMenuItem.connect( "activate" , self.onQuitActivate )

        self.add( fileMenuItem )
        fileMenu.show_all()

    def onOpenActivate( self, widget ):
        self.emit( 'open-file' )
    
    def onClearActivate( self, widget ):
        self.emit( 'clear' )

    def onQuitActivate( self, widget ):
        self.emit( 'quit' )

gobject.type_register( LogViewerMenu )
