import Plugin
import gtk
from time import *


class MainClass( Plugin.Plugin ):
    
    def __init__( self, controller, msn ):
        Plugin.Plugin.__init__( self, controller, msn )
        self.description = 'Show a list with the history of online/offline events of every contact with a timestamp.'
        self.authors = { 'mr.archano' : 'archano@gmail.com' }
        self.website = ''
        self.displayName = 'StatusHistory'
        self.name = 'StatusHistory'
        self.enabled = False
        self.controller = controller
                
    def start( self ):
        self.box = gtk.VBox()
        self.comboBox = gtk.combo_box_new_text()
        self.comboBox.prepend_text(strftime('[%H:%M:%S] Connected', localtime()))
        self.comboBox.set_active(0)
        self.box.pack_start( self.comboBox, False, False )
        self.box.show_all()
        self.controller.mainWindow.vbox.pack_start(self.box, False, False)
        self.onOnlineId = self.controller.msn.connect('user-online', self.on_online)
        self.onOfflineId = self.controller.msn.connect('user-offline', self.on_offline)
        self.enabled = True
            
    def stop( self ):
        self.controller.mainWindow.vbox.remove( self.box )
        self.disconnect( self.onOnlineId )
        self.disconnect( self.onOfflineId )
        self.enabled = False
    
    def check( self ):
        return ( True, 'Ok' )
    
    ####################
    
    def on_online( self, msnp, email, oldStatus ):
        if oldStatus == 'FLN':
            nick = msnp.contactManager.getContactNick( email )
            if len(nick) > 25:
                nick = nick[:25] + '...'
            entry = '[%H:%M:%S] '+nick+' online'
            self.comboBox.prepend_text(strftime(entry, localtime()))
            self.comboBox.set_active(0)
    
    def on_offline( self, msnp, email ):
        nick = msnp.contactManager.getContactNick( email )
        if len(nick) > 25:
            nick = nick[:25] + '...'
        entry = '[%H:%M:%S] '+nick+' offline'
        self.comboBox.prepend_text(strftime(entry, localtime()))
        self.comboBox.set_active(0)
        
