# -*- coding: utf-8 -*-

import re
import os
import gtk
import pango
import gobject

from imaplib import *

import Plugin

class MainClass( Plugin.Plugin ):

    def __init__( self, controller, msn ):
        Plugin.Plugin.__init__( self, controller, msn )

        self.description = 'A pop3 mail checker'
        self.authors = { 'Jacopo Lamanna' : 'jazzenco@fastwebnet.it' }
        self.website = 'www.jazzenco.org'
        self.displayName = 'mailChecker'
        self.name = 'mailChecker'
        self.config = controller.getConfig()
        self.config.readPluginConfig(self.name)
        self.enabled = False
        self.controller = controller
        self.isbutt = 0
        self.checking = False
        
        self.deffun = Plugin.Function( self.function, self.callback )
        
    def start( self ):
            
        self.enabled = True
        if self.isbutt == 0 :
            
            '''create the gui look'''
            self.Mbox = gtk.HBox(homogeneous=False, spacing=5)
            self.controller.mainWindow.vbox.pack_start(self.Mbox, False, False)
            self.Mbox.show_all()
            self.button = gtk.Button()
            self.button.set_relief(gtk.RELIEF_NONE)
            self.img = gtk.Image()
            self.mailIcon = self.controller.theme.getSmiley( '(e)' )
            self.img.set_from_animation(self.mailIcon)
            self.img.set_pixel_size(10)
            self.button.set_image(self.img)
            self.button.connect('clicked', self.Mcheck , None)
            self.Mbox.pack_start(self.button, False, False)
            self.button.show_all()
            
            self.Tbutton = gtk.Button()
            self.Tbutton.connect('clicked', self.Client , None)
            self.Mtext = gtk.Label('Not checked yet.')
            self.Mtext.set_ellipsize( pango.ELLIPSIZE_END )
            self.Ttooltip = gtk.Tooltips()
            self.Mtext.set_use_underline(True)
            self.Tbutton.add(self.Mtext)
            self.Tbutton.set_relief(gtk.RELIEF_NONE)
            self.Tbutton.show_all()
            self.Mbox.pack_start(self.Tbutton, True, True)
            self.Mtext.show_all()
            
            self.isbutt = 1

        self.Mcheck( None , None )
        
        self.interval = 60*1000*int(self.config.getPluginValue( self.name, 'time', '5' ))
        self.source_id = gobject.timeout_add(self.interval, self.Mcheck, self , None)

    def Client( self , widget , data=None):
        
        os.popen(self.config.getPluginValue( self.name, 'client', 'thunderbird' )+' &')
    
    def Mcheck( self , widget , data=None):
        if not self.checking:
            self.checking = True
            self.Mtext.set_label( 'checking' )
            self.deffun( data )
            
        return True
    
    def function( self, data ):
        '''this function will run on a thread and the result will be passed
        to the callback function'''
        mail = ''
        numMes = '0'
        
        try:
            server = IMAP4(self.config.getPluginValue(self.name, 'server', ''))
            server.login(self.config.getPluginValue(self.name, 'user', '' ), self.config.getPluginValue(self.name, 'pass', '' ))
        except:
            numMes = 'error'
        else:
            r = server.select()
            if r[0] == 'OK' :
                numMes = r[1][0]

                if int(numMes) <= 5:
                    numList = range(int(numMes)) 
                else:
                    numList = range(int(numMes - 5), int(numMes)) 
                
                for i in numList:
                    m = re.search('.*(?=\r\n\r\n)'  , server.fetch(i+1, '(BODY[HEADER.FIELDS (FROM)])')[1][0][1])
                    mail = mail+m.group(0)+'\n'
                    m = re.search('.*(?=\r\n\r\n)'  , server.fetch(i+1, '(BODY[HEADER.FIELDS (SUBJECT)])')[1][0][1])
                    mail = mail+m.group(0)+'\n\n'
            else:
                numMes = 'error'
        
            if numMes != 'error' and int(numMes) > 5:
                mail = mail + "and more.."
                
        self.config.setPluginValue( self.name, 'numMes', numMes )
        server.logout()
        return (numMes,mail)
        
    def callback( self, args ):
        numMes,mail = args
        self.checking = False
        if numMes == 'error' :
            self.Mtext.set_label('Server error')
        else:
            if numMes >= '1' :
                self.Mtext.set_label(numMes+' messages for '+self.config.getPluginValue( self.name, 'user','user'))
                self.Ttooltip.set_tip( self.Tbutton, _(mail) )
            else:
                self.Mtext.set_label('No messages for '+self.config.getPluginValue( self.name, 'user','user'))
                self.Ttooltip.set_tip( self.Tbutton, 'No new messages' )
   
    def stop( self ):
        self.enabled = False
        gobject.source_remove(self.source_id)
        self.controller.mainWindow.vbox.remove( self.Mbox )
        self.isbutt = 0

    def check( self ):
        return ( True, 'Ok' )

    def configure( self ):
        dataM = []
        dataM.append( Plugin.Option( 'time', str, 'Check every [min]:', '', self.config.getPluginValue( self.name, 'time', '5' )) )
        dataM.append( Plugin.Option( 'server', str, 'imap server:', '', self.config.getPluginValue( self.name, 'server', 'pop.test.com' )) )
        dataM.append( Plugin.Option( 'client', str, 'client to execute:', '', self.config.getPluginValue( self.name, 'client', 'thunderbird' )) )
        dataM.append( Plugin.Option( 'user', str, 'username:', '', self.config.getPluginValue( self.name, 'user', 'user')) )
        
        #dataM.append( Plugin.Option( 'pass', str, 'password:', '', self.config.getPluginValue( self.name, 'pass', '*****')) )        
        
        self.confW = Plugin.ConfigWindow( 'Mail checker config', dataM)
        
        #Let's keep the pass entry secret
        label = gtk.Label( 'password:' )
        label.set_justify(gtk.JUSTIFY_LEFT)
        label.set_width_chars( 20 )
        entry = gtk.Entry()
        entry.set_text( '*****' )
        entry.set_visibility(False) #with this op.
        hbox = gtk.HBox()
        hbox.pack_start( label )
        hbox.pack_start( entry )
        self.confW.vbox.pack_start( hbox )
        self.confW.vbox.show_all()
        
        Result = self.confW.run()
        passwd = str(entry.get_text())
        
        if Result != None:
            self.config.setPluginValue( self.name, 'time', Result[ 'time' ].value )
            self.config.setPluginValue( self.name, 'server', Result[ 'server' ].value )
            self.config.setPluginValue( self.name, 'user', Result[ 'user' ].value )
            self.config.setPluginValue( self.name, 'pass', passwd )
            self.config.setPluginValue( self.name, 'client', Result[ 'client' ].value )
            
        #self.start()
        return True

